<div class="basicSearch">
  <app-loading *ngIf="isLoadingPage"></app-loading>

  <!-- Form Search -->
  <app-search-form-approval #searchForm (keyup.enter)="doSearch(1)"></app-search-form-approval>
  <!--End: Form Search -->

  <div nz-row class="btn__row">
    <div nz-col nzSpan="8"></div>
    <div nz-col nzSpan="8">
      <div style="text-align: center">
        <mb-button
          class="staff__research__btn__search"
          mbButtonSize="MEDIUM"
          mbButtonAvailableStyle="SEARCH"
          (click)="doSearch(1)"
          mbButtonText="{{'partnership.label.search' | translate}}"
        ></mb-button>
      </div>
    </div>
    <div nz-col nzSpan="8"></div>
  </div>

</div>


<div class="search__result">
  <mb-table-merge-cell-wrap>
    <div class="headerTableSelect" *ngIf="objFunction?.approve">
      <!-- Phê duyệt tất cả -->
      <mb-button
        *ngIf="curAmountValidApprovalRecord > 0"
        mbButtonSize="SMALL"
        mbButtonAvailableStyle="PRIMARY"
        mbButtonText="{{'partnership.pns-contract.contractApproval.label.approveAll' | translate}}"

        nz-popconfirm="true"
        nzPopconfirmTitle="{{'partnership.pns-contract.contractApproval.label.confirmApproveAll' | translate: {amountRecord: curAmountValidApprovalRecord} }}"
        nzPopconfirmPlacement="bottomLeft"
        nzOkText="{{'partnership.pns-contract.contractApproval.label.agree' | translate}}"
        (nzOnConfirm)="onApproveAllClick()"
      ></mb-button>
      <mb-button
        *ngIf="curAmountValidApprovalRecord === 0"
        mbButtonSize="SMALL"
        mbButtonAvailableStyle="PRIMARY"
        mbButtonText="{{'partnership.pns-contract.contractApproval.label.approveAll' | translate}}"
        (click)="onApproveAllClick()"
      ></mb-button>
      <!--End: Phê duyệt tất cả -->
      <!-- Phê duyệt -->
      <mb-button
        *ngIf="contractApproverSet.size > 0"
        mbButtonSize="SMALL"
        mbButtonAvailableStyle="PRIMARY"
        mbButtonText="{{'partnership.pns-contract.contractApproval.label.approve' | translate}}"
        (click)="onApproveListClick()"
      ></mb-button>
      <!--End: Phê duyệt -->
      <!-- Thanh lý -->
      <mb-button
        *ngIf="contractApproverSet.size > 0"
        mbButtonSize="SMALL"
        mbButtonAvailableStyle="DANGER"
        mbButtonText="{{'partnership.pns-contract.label.liquidate' | translate}}"
        (click)="onLiquidateListClick()"
      ></mb-button>
      <!--End: Thanh lý -->
    </div>
    <mb-table-merge-cell
      #table
      (changePageNum)="doSearch($event)"
      [tableConfig]="tableConfig"
      [dataList]="dataTable"
      (dblClickRow)="onDetail($event)"
      (amountSelectedRowsChange)="onAmountSelectedRowChange($event)"
    ></mb-table-merge-cell>
  </mb-table-merge-cell-wrap>
</div>


<!--Hành động-->
<ng-template #actionTmpl
             let-status="status" let-contractProposalId="contractProposalId"
             let-contractApproverId="contractApproverId" let-liquidationStatusOfNext="liquidationStatusOfNext"
             let-approverLevel="approverLevel"
             let-dmIsLiquidation="dmIsLiquidation"
             let-alIsLiquidation="alIsLiquidation"
             let-calCursorCurrent="calCursorCurrent"
             let-contractByLawId="contractByLawId"
             let-dmContractTypeId="dmContractTypeId"
             let-alContractTypeId="alContractTypeId"
>
  <em nz-icon
     class="menu__item--btn"
     nz-button
     nzType="more"
     nzTheme="outline"
     nzTrigger="click"
     nz-dropdown
     [nzDropdownMenu]="menu"
  ></em>
  <nz-dropdown-menu #menu="nzDropdownMenu">
    <ul nz-menu class="btnListWrap">
      <li
        [nzFullDisabled]="'APPROVE'|isDisabledActionCa:status:liquidationStatusOfNext:approverLevel:dmIsLiquidation:alIsLiquidation:calCursorCurrent:contractByLawId:dmContractTypeId:alContractTypeId"
        nz-button
        nz-menu-item
        class="btnItem"
        (click)="onApproveClick(contractProposalId)"
        *ngIf="objFunction?.approve"
      >
        <div class="menu__item">
          <em nz-icon nzType="check" nzTheme="outline" class="iconClass"></em>
          <span>{{'partnership.pns-contract.label.approve' | translate}}</span>
        </div>
      </li>
      <li
        [nzFullDisabled]="'LIQUIDATE'|isDisabledActionCa:status:liquidationStatusOfNext:approverLevel:dmIsLiquidation:alIsLiquidation:calCursorCurrent:contractByLawId:dmContractTypeId:alContractTypeId"
        nz-button
        nz-menu-item
        class="btnItem"
        (click)="onLiquidateClick(contractProposalId)"
        *ngIf="objFunction?.approve"
      >
        <div class="menu__item">
          <em nz-icon nzType="stop" nzTheme="outline" class="iconClass"></em>
          <span>{{'partnership.pns-contract.label.liquidate' | translate}}</span>
        </div>
      </li>
      <li
        [nzFullDisabled]="'EDIT'|isDisabledActionCa:status:liquidationStatusOfNext:approverLevel:dmIsLiquidation:alIsLiquidation:calCursorCurrent:contractByLawId:dmContractTypeId:alContractTypeId"
        nz-button
        nz-menu-item
        class="btnItem"
        (click)="onEditClick(contractApproverId)"
        *ngIf="objFunction?.edit"
      >
        <div class="menu__item">
          <em nz-icon nzType="edit" nzTheme="outline" class="iconClass"></em>
          <span>{{'partnership.pns-contract.label.edit' | translate}}</span>
        </div>
      </li>
      <li
        [nzFullDisabled]="'EVALUATE'|isDisabledActionCa:status:liquidationStatusOfNext:approverLevel:dmIsLiquidation:alIsLiquidation:calCursorCurrent:contractByLawId:dmContractTypeId:alContractTypeId"
        nz-button
        nz-menu-item
        class="btnItem"
        (click)="onEvaluateClick(contractApproverId)"
        *ngIf='approverLevel === constant.USER_LOGIN_LEVEL.DIRECT_MANAGER && objFunction?.approve'
      >
        <div class="menu__item">
          <span nz-icon nzType="form" nzTheme="outline" style="margin-right: 10px"></span>
          <span>{{'partnership.pns-contract.label.evaluate' | translate}}</span>
        </div>
      </li>
      <li
        nz-button
        nz-menu-item
        class="btnItem"
        (click)="onDetailClick(contractApproverId)"
        *ngIf="objFunction?.view"
      >
        <div class="menu__item">
          <span nz-icon nzType="eye" nzTheme="outline" style="margin-right: 10px"></span>
          <span>{{'partnership.pns-contract.label.detail' | translate}}</span>
        </div>
      </li>
    </ul>
  </nz-dropdown-menu>
</ng-template>
<!--End: Hành động-->


<ng-template #statusTmpl let-status='status'>
  <ng-container *ngFor='let item of constant.SIGN_STATUS'>
    <nz-tag [nzColor]="item.bgColor" [ngStyle]="{'color': item.color}" *ngIf='status.toString() === item.value'>{{item.label | translate}}</nz-tag>
  </ng-container>
</ng-template>


<!--Modal Xác nhận thanh lý-->
<nz-modal
  [(nzVisible)]="isShowLiquidateModal"
  nzTitle="{{'partnership.pns-contract.contractApproval.label.isConfirmLiquidate' | translate}}"
  (nzOnCancel)="onLiquidateModalClose()"
  nzCancelText="{{'partnership.table.action.cancel' | translate}}"
  nzOkType="primary"
  nzOkText="{{'partnership.table.action.yes' | translate}}"
  (nzOnOk)="doLiquidate()"
>
  <form nz-form [formGroup]="reasonForm" *nzModalContent>
    <div nz-row>
      <div nz-col [nzXs]="24" [nzLg]="24">
        <mb-input-text
          [mbIsTextAre]="true"
          [mbMaxLength]="500" [mnMinLength]="0"
          [mbType]="isSubmittedFormReason && reasonForm.controls['rejectReason'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmittedFormReason && reasonForm.controls['rejectReason'].errors !== null"
          [mbErrors]="reasonForm.controls['rejectReason'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'partnership.validate.required' | translate: {'param': 'partnership.label.rejectReason' | translate }}]"
          mbLabelText="{{'partnership.label.rejectReason' | translate}} <span class='label__required'>*</span>"
          formControlName="rejectReason"
        >
        </mb-input-text>
      </div>
    </div>
  </form>
</nz-modal>
<!--End: Modal Xác nhận thanh lý-->
